<?php
/**
* @package Shared_lib
*
* A collection of useful functions for use in PHP projects
*
* auth.php contains Authenication related functions
*
* @copyright Copyright (C) 2011 B Tasker
* @license  GPLV3, see LICENSE
*/




/**
* Return a random string for use when salting passwords
*
* @return string containing a random number
*/
function generate_salt()
{
$salt = mt_rand();
return $salt;

}



/**
* Salt a password and return the salted hash
* Accepts two salts
*
* Note: Changes to salting procedure _will_ mean that passwords
* need to be reset in any project using this function
*
* @param string password - plaintext password to be salted
* @param string salt1 - a string to be prepended to the password before hashing
* @param string salt2 - a string to be appended to the password before hasing
* @return string containing a salted hash generated with the sha1 algorithm
*
*/
function salt_pass($password,$salt1,$salt2)
{

// Generate our salt

$password = $salt1 . $password . $salt2 ;

// Hash the password

$password = sha1($password);

return $password;

}






?>