<?php
/**
* @package Shared_lib
*
* A collection of useful functions for use in PHP projects
*
* shared_lib.php contains functions which don't fit into other categories as well as calling all other components.
*
* @copyright Copyright (C) 2011 B Tasker
* @license License: GPLV3, see LICENSE
*/

// Include the other parts of the library
$basedir = dirname(__FILE__) . '/..';
include_once($basedir . '/Shared_lib/db.php');
include_once($basedir . '/Shared_lib/auth.php');
include_once($basedir . '/Shared_lib/files.php');
include_once($basedir . '/Shared_lib/http.php');





/**
* mime_content_type has been depreceated but is superior
* in some cases to finfo
*
* If function is unavailable, make it available
* slightly different methodology unfortunately
*
* @param string file - Path to the file to return mimetype of
* @return string containing mime-type of file
*/
function test_for_mime_content_type()
{
if (!function_exists('mime_content_type'))
{
   function mime_content_type($file)
   {
       return trim(exec('file -bi ' . escapeshellarg($file)));
   }
}
}



/**
* Detect whether we've been called from the CLI or a CGI
* script
*
* @param none
* @return false/true - do we appear to have been called from a CLI?
*
*/
function CliorCGI() {
 
     if(php_sapi_name() == 'cli' && empty($_SERVER['REMOTE_ADDR'])) {
          return true;
     } else {

/* First check doesn't always work, some hosts symlink /usr/bin/php to the
   CGI rather than the CLI exectuable
*/

if(!isset($_SERVER['SHELL'])){
return false;

} else {
return true;
}
     }
}


test_for_mime_content_type();

?>