<?php
/**
* This file is part of the BUGGER Library 
*
* Copyright (C) 2011 B Tasker
* License: GPLV3, see LICENSE
*/

include_once 'lib/db/insert.php';
include_once 'lib/auth.php';

function get_current_time()
{
$curtime = date(("d-m-Y H:i"));
return $curtime;
}

function add_release()
{
// OK We should have been passed some data!

$newdata['Project'] = $_POST['Project'];
$newdata['Patch'] = $_POST['Patch'];
$newdata['Version'] = $_POST['Version'];
$newdata['Security'] = $_POST['Security'];
$newdata['RegisteredDate'] = date(("j/n/Y"));
$newdata['License'] = $_POST['License'];
$newdata['MD5'] = $_POST['MD5'];
$newdata['Notes'] = $_POST['Notes'];


// Temp
$newdata['User'] = get_current_user_name();

// The rest we grab from the global files

$fileName = $_FILES['File']['name'];
$tmpName  = $_FILES['File']['tmp_name'];
$fileSize = $_FILES['File']['size'];
$fileType = $_FILES['File']['type'];

$fp      = fopen($tmpName, 'r');
$content = fread($fp, filesize($tmpName));
$content = addslashes($content);
fclose($fp);

if(!get_magic_quotes_gpc())
{
    $fileName = addslashes($fileName);
}

$result = insert_release_record($newdata,$fileName,$fileSize,$fileType,$content);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Record Inserted";
}



}


function add_doc()
{
// OK We should have been passed some data!





/*
FORM FIELDS
Project
Doctitle
Docversion
Docdescription
DocSec
File
*/

$newdata['Project'] = $_POST['Project'];
$newdata['Title'] = $_POST['Doctitle'];
$newdata['Version'] = $_POST['Docversion'];
$newdata['Security'] = $_POST['DocSec'];
$newdata['Description'] = $_POST['Docdescription'];
$newdata['RegisteredDate'] = date(("j/n/Y"));
$newdata['License'] = $_POST['License'];




// Temp
$newdata['User'] = get_current_user_name();

// The rest we grab from the global files

$fileName = $_FILES['File']['name'];
$tmpName  = $_FILES['File']['tmp_name'];
$fileSize = $_FILES['File']['size'];
$fileType = $_FILES['File']['type'];

$fp      = fopen($tmpName, 'r');
$content = fread($fp, filesize($tmpName));
$content = addslashes($content);
fclose($fp);

if(!get_magic_quotes_gpc())
{
    $fileName = addslashes($fileName);
}

$result = insert_document_record($newdata,$fileName,$fileSize,$fileType,$content);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Record Inserted";
}



}


function add_user()
{

// Username quite possibly isn't in Session
$idkey = $_POST['key'];
$username = $_POST['user'];

$results = db_validate_user_auth_token($idkey,$username,"adduser");

if ($results['auth'] == 1)
{
// Set our Session vars for the benefit of the interested functions

$_SESSION['loggedin'] = 1;
$_SESSION['User'] = $results['UserName'];

}



if (check_user_priviliges_access("A") == "1")
{
// We should have been passed some data in POST

$newdata['Username'] = $_POST['Username'];
$newdata['DisplayName'] = $_POST['DisplayName'];
$newdata['E-Mail'] = $_POST['Email'];
$newdata['Disabled'] = $_POST['Disabled'];
$newdata['Moderator'] = $_POST['Moderator'];
$newdata['Developer'] = $_POST['Developer'];
$newdata['Admin'] = $_POST['Admin'];
$newdata['LastUpdatedBy'] = get_current_user_name();
$newdata['LastUpdated'] = date(("j/n/Y"));
$newdata['S1'] = generate_salt();
$newdata['S2'] = generate_salt();
$newdata['LastChanged'] = date(("j/n/Y"));
$newdata['Password'] = salt_pass($_POST['Password'],$newdata['S1'],$newdata['S2']);
$newdata['LastUpdated'] = date(("j/n/Y"));


// Pass to the DB
$result = db_insert_add_user($newdata);

include 'config/config.php';
if ($result != "1")
{
header("Location: $plainconnection/adduser.php?stat=2");

}
else
{
header("Location: $plainconnection/adduser.php?stat=1");

}

}
}



function update_changelog()
{
$privset = check_user_priviliges_access("D");

if ($privset == 1)
{
$newdata['Project'] = $_POST['Project'];
$newdata['Date'] = $_POST['Date'];
$newdata['Change'] = htmlspecialchars($_POST['Change']);
$newdata['User'] = get_current_user_name();

// Pass to the database

$result = db_insert_new_change($newdata);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Saved!";
}
}
}



function add_task()
{


$privset = check_user_priviliges_access("D");

if ($privset == 1)
{

$newdata['Project'] = $_POST['Project'];
$newdata['Date'] = $_POST['Date'];
$newdata['Task'] = $_POST['Task'];
$newdata['Userref'] = get_current_user_name();

$result = db_insert_new_task($newdata);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Saved!";
}

}
}


function add_project()
{
$privset = check_user_priviliges_access("D");

if ($privset == 1)
{

$newdata['ProjectName'] = $_POST['Project'];
$newdata['StartDate'] = $_POST['Date'];
$newdata['ProjectDesc'] = nl2br($_POST['ProjectDesc']);
$newdata['Maintainer'] = get_current_user_name();
$newdata['Public'] = $_POST['Public'];

$result = db_insert_new_project($newdata);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Saved!";
}


}
}



function edit_project()
{
$privset = check_user_priviliges_access("D");

if ($privset == 1)
{

$newdata['ProjectRef'] = $_POST['Project'];
$delete = $_POST['delete'];



if ($delete != 1)
{

$newdata['ProjectName'] = $_POST['ProjectName'];
$newdata['StartDate'] = $_POST['Date'];
$newdata['DevelopmentStopped'] = $_POST['DevelStopped'];
$newdata['ProjectDesc'] = nl2br($_POST['ProjectDesc']);
$newdata['Maintainer'] = $_POST['Developer'];
$newdata['Public'] = $_POST['Public'];

$result = db_insert_edit_project($newdata);

$confirm = "Saved!";
}
else
{
// Delete the project
$result = db_delete_project($newdata['ProjectRef']);

$confirm = "Deleted!";
}


if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "$confirm";
}

}
}


function add_bug()
{

if ( $_POST['ans'] == 4 )
{

$newdata['Project'] = $_POST['Project'];
$newdata['BriefDesc'] = str_replace("\n","",nl2br(htmlspecialchars($_POST['BriefDesc'])));

$curruser = get_current_user_name();


if (!empty($curruser))
{
$currusername = get_user_displayname($curruser);
$newdata['Loggedby'] = $currusername;
}
else
{

$newdata['Loggedby'] = $_POST['reportname'];
}


$newdata['Datelogged'] = date(("j/n/Y"));


$result = db_report_new_bug($newdata);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Saved! Thank you";
}
}
else
{
echo "Invalid answer provided";
}

}

function mark_task_complete()
{
$privset = check_user_priviliges_access("D");

if ($privset == 1)
{

$result = db_mark_task_complete($_POST['Taskref']);


if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Saved!";
}


}
}



function process_edit_bug_update()
{


$privset = check_user_priviliges_access("D");

if ($privset == 1)
{


$newdata['Bugstatus'] = $_POST['bugstat'];
$newdata['BugRef'] = $_POST['BugRef'];
$newdata['BriefDesc'] = nl2br($_POST['Desc']);
$newdata['AssignedTo'] = $_POST['Developer'];
$newdata['DeveloperNotes'] = nl2br($_POST['DevelNotes']);


$result = db_update_bug_dets($newdata);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Saved!";
}


}

}


function process_edit_bug_delete()
{


$privset = check_user_priviliges_access("D");

if ($privset == 1)
{


$bug = $_POST['bugid'];


$result = db_delete_bug($bug);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Deleted!";
}


}

}



function process_comment_delete()
{


$privset = check_user_priviliges_access("M");

if ($privset == 1)
{


$comment = $_POST['comment'];


$result = db_delete_comment($comment);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Deleted!";
}


}

}


function process_add_bugcomment()
{
// Some of the data we need is in POST, the rest we need to collect ourselves
$curuser = get_current_user_name();
if ((!empty($curuser)) && ($_POST['Comment'] != "Enter your comment, no HTML allowed"))
{

$newdata['BugRef'] = $_POST['BugRef'];
$newdata['Comment'] = nl2br(htmlspecialchars($_POST['Comment']));
$newdata['DisplayName'] = htmlspecialchars($_POST['DisplayName']);
$newdata['Project'] = $_POST['Project'];


// The rest we need to collect ourselves
$newdata['CommentDate'] = get_current_time();
$newdata['Hostname'] = get_remote_host();
$newdata['Abuse'] = 0;
$newdata['Username'] = $curuser;

// Add the comment to the database
$result = db_add_new_comment($newdata);

if ($result != 1)
{
echo "Sorry could not log the comment";
}
else
{
echo "Comment added. <a href=\"Javascript: history.go(-1)\">Go Back</a>\n";
}

}
}


function process_abuse_report()
{

$comment = $_GET['commentID'];

$result = db_report_comment($comment);

if ($result != "1")
{
echo "An error occurred";
}
else
{
echo "Reported!";
}


}

?>
